CREATE OR REPLACE FUNCTION f_add_nr RETURN NUMBER IS
    v_out_nr NUMBER := 0;
BEGIN
    FOR i IN 1..9999999 LOOP
        v_out_nr := v_out_nr + i;
    END LOOP;
    RETURN v_out_nr;
END;
/

exec runstats_pkg.rs_start;
ALTER FUNCTION f_add_nr COMPILE PLSQL_CODE_TYPE=INTERPRETED;

BEGIN
    dbms_output.put_line(f_add_nr);
END;
/
EXEC runstats_pkg.rs_middle;

ALTER FUNCTION f_add_nr COMPILE PLSQL_CODE_TYPE=NATIVE;
BEGIN
    dbms_output.put_line(f_add_nr);
END;
/
EXEC runstats_pkg.rs_stop(10);
