CREATE OR REPLACE FUNCTION f_heavy_tx (i_deptno number) RETURN VARCHAR2 IS
BEGIN 
    RETURN 'Heavy:'||i_deptno; 
END;
/
CREATE OR REPLACE FUNCTION f_light_tx (i_empno number) RETURN VARCHAR2 IS
BEGIN 
    RETURN 'Light:'||i_empno; 
END;
/
ASSOCIATE STATISTICS WITH FUNCTIONS f_light_tx
    DEFAULT COST (0,0,0)
/      
ASSOCIATE STATISTICS WITH FUNCTIONS f_heavy_tx
    DEFAULT COST (99999,99999,99999)
/    
SET AUTOTRACE ON EXPLAIN
SELECT count(*) 
FROM emp
WHERE f_heavy_tx(deptno) = 'A'
OR f_light_tx(empno) = 'B'
/