-- this table will be used all over the book
CREATE TABLE test_tab AS
SELECT *
FROM all_objects
WHERE ROWNUM <= 50000
/
-- create sample function
CREATE OR REPLACE FUNCTION f_change_udf_nr (i_nr NUMBER) 
RETURN NUMBER
IS
    PRAGMA UDF;
BEGIN
    counter_pkg.v_nr:=counter_pkg.v_nr+1;
    RETURN i_nr+1;
END;
/
-- compare execution times
set timing on
SELECT MAX(f_change_nr(object_id)) FROM TEST_TAB
/
SELECT MAX(f_change_udf_nr(object_id)) FROM TEST_TAB
/
DECLARE
    v_out_nr NUMBER;
BEGIN
    FOR i IN 1..1000000 loop
        v_out_nr:=f_change_nr(i)+f_change_nr(i+1);
    END LOOP;
END;
/
DECLARE
    v_out_nr NUMBER;
BEGIN
    FOR i IN 1..1000000 LOOP
        v_out_nr:=f_change_udf_nr(i)+f_change_udf_nr(i+1);
    END LOOP;
END;
/