-- Positive impact: execution plans
ALTER TABLE emp ADD CONSTRAINT emp_sal_ck CHECK (sal<=5000)
/
SET AUTOTRACE TRACEONLY EXPLAIN
SELECT * FROM emp WHERE sal > 10000
/
ALTER TABLE emp DISABLE CONSTRAINT emp_sal_ck
/
SELECT * FROM emp WHERE sal > 10000
/

-- Negative impact: only one error 
ALTER TABLE emp ADD CONSTRAINT emp_comm_ck CHECK (comm<=2000)
/
UPDATE emp
SET sal=10000,  -- failure #1
    comm=3000   -- failure #2
WHERE empno=7902
/
