CREATE TABLE testlob_xml 
    (id NUMBER, 
     a_xml XMLTYPE)
/    
-- check default
SELECT column_name, cache 
FROM user_lobs 
WHERE table_name = 'TESTLOB_XML'
/
ALTER TABLE testlob_xml ADD b_xml XMLTYPE
XMLTYPE COLUMN b_xml
STORE AS SecureFile CLOB testlob_b_seg (CACHE)
/
-- confirm explicit settings
SELECT column_name,segment_name,cache
FROM user_lobs
WHERE table_name = 'TESTLOB_XML'
/
-- various options
ALTER TABLE testlob_xml ADD c_xml XMLTYPE XMLTYPE COLUMN c_xml
STORE AS SECUREFILE BINARY XML testlob_c_seg
/
ALTER TABLE testlob_xml ADD d_xml XMLTYPE XMLTYPE COLUMN d_xml
STORE AS BASICFILE BINARY XML testlob_d_seg
/
ALTER TABLE testlob_xml ADD e_xml XMLTYPE XMLTYPE COLUMN e_xml
STORE AS SECUREFILE CLOB testlob_e_seg
/
ALTER TABLE testlob_xml ADD f_xml XMLTYPE XMLTYPE COLUMN f_xml
STORE AS BASICFILE CLOB testlob_f_seg
/
select column_name,segment_name,cache
from user_lobs
where table_name = 'TESTLOB_XML'
/