CREATE OR REPLACE PACKAGE emp_dynamic_sql IS
    TYPE idList_tt IS TABLE OF NUMBER;
    PROCEDURE p_testList;
END;
/
CREATE OR REPLACE PACKAGE BODY emp_dynamic_sql IS
    PROCEDURE p_testList is
       v_tt idList_tt:=idList_tt(10,20);
        v_table_tx VARCHAR2(30):='scott.emp';
        v_out_nr NUMBER;
    BEGIN
        EXECUTE IMMEDIATE 'select count(*) FROM '||v_table_tx||
                        ' WHERE DEPTNO IN (SELECT column_value FROM table(:1))'
        INTO v_out_nr
        USING v_tt;
        dbms_output.put_line('Count:'||v_out_nr);
    END;
END;
/
exec emp_dynamic_sql.p_testList;