CREATE TABLE dynamic_sql_q1 (a NUMBER)
/
CREATE TABLE dynamic_sql_q2 (a NUMBER)
/
CREATE TABLE dynamic_sql_q3 (a NUMBER)
/
-- run code snippet and review trace
BEGIN
    dbms_monitor.session_trace_enable(waits=>true, binds=>true);
    FOR i IN 1..50 LOOP
        EXECUTE IMMEDIATE 'INSERT INTO dynamic_sql_q1(a) VALUES (:1)' USING i;
        EXECUTE IMMEDIATE 'INSERT INTO dynamic_sql_q2(a) VALUES (:1)' USING i;
    END LOOP;
    dbms_monitor.session_trace_disable;
END;
/
-- run code snippet and review trace
DECLARE
    v_tt dbms_sql.Number_Table;
BEGIN
    FOR i IN 1..50 LOOP
        v_tt(i):=i;
    END LOOP;
    dbms_monitor.session_trace_enable(waits=>true, binds=>true);
    
    FORALL i IN INDICES OF v_tt
        EXECUTE IMMEDIATE 'insert into dynamic_sql_q3(a) values (:1)'
    USING v_tt(i);
    
    dbms_monitor.session_trace_disable;
END;
/
