-- Classical example
CREATE OR REPLACE FUNCTION f_factorial_nr(in_nr INTEGER) RETURN NUMBER AS
BEGIN
    IF in_nr in (0,1) THEN -- Checking for last value to process of n-1
        RETURN 1;
    ELSIF in_nr < 0 then
        return null;
    ELSE
        RETURN(in_nr * f_factorial_nr(in_nr-1)); -- Recursive
    END IF;
END;
/