-- create testing modules
CREATE OR REPLACE PROCEDURE p_testNumber IS
    v_nr NUMBER:=1;
BEGIN
    FOR i IN 1..1000000 LOOP
        v_nr:=v_nr+1+3*v_nr-2*v_nr-v_nr;
    END LOOP;
END;
/
CREATE OR REPLACE PROCEDURE p_testBinaryInteger is
    v_nr BINARY_INTEGER:=1;
BEGIN
    FOR i IN 1..1000000 LOOP
        v_nr:=v_nr+1+3*v_nr-2*v_nr-v_nr;
    END LOOP;
END;
/
CREATE OR REPLACE PROCEDURE p_testSimpleInteger IS
    v_nr SIMPLE_INTEGER:=1;
BEGIN
    FOR i IN 1..1000000 LOOP
        v_nr:=v_nr+1+3*v_nr-2*v_nr-v_nr;
    END LOOP;
END;
/
-- compare all cases (including native compilation)
set timing on
exec p_testNumber;
exec p_testBinaryInteger;
exec p_testSimpleInteger;
ALTER SESSION SET PLSQL_CODE_TYPE=NATIVE;
ALTER PROCEDURE p_testSimpleInteger COMPILE;
exec p_testSimpleInteger;