set timing on
set serveroutput on
-- Test #1: remove all numeric symbols
DECLARE
    v_source_tx VARCHAR2(100):='0A.0B.0C.0D.0E';
    v_dest_tx VARCHAR2(100);
BEGIN
    FOR i IN 1..100000 LOOP
        v_dest_tx:=REGEXP_replace(v_source_tx||i, '[[:digit:]\.]');
    END LOOP;
    dbms_output.put_line(v_dest_tx);
END;
/
DECLARE
    v_source_tx VARCHAR2(100):='0A.0B.0C.0D.0E';
    v_dest_tx VARCHAR2(100);
BEGIN
    FOR i IN 1..100000 LOOP
        v_dest_tx:=regexp_REPLACE(v_source_tx||i, '[0123456789\.]');
    END LOOP;
    dbms_output.put_line(v_dest_tx);
END;
/
DECLARE
    v_source_tx VARCHAR2(100):='0A.0B.0C.0D.0E';
    v_dest_tx VARCHAR2(100);
BEGIN
    FOR i IN 1..100000 LOOP
        v_dest_tx:=translate(v_source_tx||i,'-0123456789.','-');
    END LOOP;
    dbms_output.put_line(v_dest_tx);
END;
/
-- Test #2: keep all numeric symbols
exec runstats_pkg.rs_start;
DECLARE
    v_source_tx VARCHAR2(100):='0A.0B.0C.0D.0E';
    v_dest_tx VARCHAR2(100);
BEGIN
    FOR i IN 1..100000 LOOP
        v_dest_tx:=regexp_REPLACE(v_source_tx||i, '[^[:digit:]\.]');
    END LOOP;
    dbms_output.put_line(v_dest_tx);
END;
/
exec runstats_pkg.rs_middle;
DECLARE
    v_source_tx VARCHAR2(100):='0A.0B.0C.0D.0E';
    v_dest_tx VARCHAR2(100);
BEGIN
    FOR i IN 1..100000 LOOP
        v_dest_tx:=TRANSLATE(v_source_tx||i,'0'||
            TRANSLATE(v_source_tx||i,'-0123456789.','-'),'0');
    END LOOP;
    dbms_output.put_line(v_dest_tx);
end;
/
exec runstats_pkg.rs_stop();
