WITH text as
    (SELECT text_tx, rownum row_nr
    FROM XMLTABLE('"Misha","Masha","Ahsam","Babushka"'
                COLUMNS text_tx VARCHAR2(10) PATH '.') t
    )
SELECT a.text_tx from_tx, b.text_tx to_tx,
        utl_match.edit_distance (a.text_tx,b.text_tx) dist_nr,
        utl_match.edit_distance_similarity(a.text_tx,b.text_tx) similar_nr
FROM text a,
    text b
WHERE a.text_tx!=b.text_tx
AND a.row_nr <=b.row_nr 
/
WITH text AS
    (SELECT text_tx, rownum row_nr
     FROM XMLTABLE('"Misha","Masha","Ahsam","Babushka"'
                    COLUMNS text_tx VARCHAR2(10) PATH '.') t
)
SELECT a.text_tx from_tx, b.text_tx to_tx,
        UTL_MATCH.jaro_winkler (a.text_tx,b.text_tx) dist_nr,
        utl_match.jaro_winkler_similarity(a.text_tx,b.text_tx) similar_nr
FROM text a,
     text b
WHERE a.text_tx!=b.text_tx
AND a.row_nr <=b.row_nr
/
