-- NOCOPY performance impacta
CREATE OR REPLACE PROCEDURE p_testCopy IS
    v_before_nr NUMBER;
    v_after_nr NUMBER;
    v_level_nr NUMBER:=0;
    type list_tt IS TABLE OF VARCHAR2(32767);
    v_tt list_tt:=list_tt();
    PROCEDURE p_DrillDown(pi_tt IN OUT list_tt) IS
    BEGIN
        pi_tt(v_level_nr+1):=lpad('Z',32767,'Z');
        v_level_nr:=v_level_nr+1;
        IF v_level_nr <=10 THEN
            p_DrillDown(pi_tt);
        END IF;
    END;
BEGIN
    v_tt.extend();
    v_tt(1):=LPAD('A',32767,'A');
    v_tt.extend(999,1);
    v_before_nr:=f_getPGA_nr;
    p_DrillDown(v_tt);
    v_after_nr:=f_getPGA_nr;
    dbms_output.put_line('Usage:'||(v_after_nr-v_before_nr));
END;
/
CREATE OR REPLACE PROCEDURE p_testNocopy IS
    v_before_nr NUMBER;
    v_after_nr NUMBER;
    v_level_nr NUMBER:=0;
    type list_tt IS TABLE OF VARCHAR2(32767);
    v_tt list_tt:=list_tt();
    PROCEDURE p_DrillDown(pi_tt IN OUT NOCOPY list_tt) IS
    BEGIN
        pi_tt(v_level_nr+1):=lpad('Z',32767,'Z');
        v_level_nr:=v_level_nr+1;
        IF v_level_nr <=10 THEN
            p_DrillDown(pi_tt);
        END IF;
    END;
BEGIN
    v_tt.extend();
    v_tt(1):=LPAD('A',32767,'A');
    v_tt.extend(999,1);
    v_before_nr:=f_getPGA_nr;
    p_DrillDown(v_tt);
    v_after_nr:=f_getPGA_nr;
    dbms_output.put_line('Usage:'||(v_after_nr-v_before_nr));
END;
/
set timing on
exec p_testCOPY;
exec p_testNOCOPY;