-- Proof of functionality: define call rights
CREATE OR REPLACE PROCEDURE p_testAccess1
ACCESSIBLE BY (procedure p_testAccess2)
IS
BEGIN
    dbms_output.put_line('Inside of protected module'); 
END;
/
-- Check direct call
CREATE OR REPLACE PROCEDURE p_testAccess2
IS
BEGIN 
    p_testAccess1; 
END;
/
exec p_testAccess2;
exec p_testAccess1;
-- Check reference
CREATE OR REPLACE PROCEDURE p_testAccess_reference
IS
BEGIN
    p_testAccess1;
END;
/
show err
