ALTER FUNCTION f_add_nr COMPILE PLSCOPE_SETTINGS='IDENTIFIERS:ALL';

column name format A20
column type format A10

SELECT LPAD(' ', LEVEL*2, ' ') || name AS name,
        type, usage, usage_id, line, col
FROM user_identifiers
WHERE object_name = 'F_ADD_NR'
START WITH usage_context_id = 0
CONNECT BY PRIOR usage_id = usage_context_id;
