set serveroutput on

DECLARE
    PROCEDURE my_stack IS
        v_depth_nr NUMBER:=utl_call_stack.dynamic_depth;
    BEGIN
        FOR i IN 1..v_depth_nr LOOP
            dbms_output.put_line(
                RPAD(i,4,' ')||
                RPAD(utl_call_stack.unit_line(i),4,' ')||
                utl_call_stack.concatenate_subprogram
                    (utl_call_stack.subprogram(i)));
        END LOOP;
    END;

    PROCEDURE p_misha02 IS
    BEGIN
        dbms_output.put_line('***** Old way *****');
        dbms_output.put_line(dbms_utility.format_call_stack); -- old way
        dbms_output.put_line('***** New way *****');
        my_stack; -- new way
    END;
    
    PROCEDURE p_misha01 IS
    BEGIN
        p_misha02;
    END;
BEGIN
    p_misha01;
END;
/