DECLARE
    PROCEDURE error_stack IS
        v_depth_nr NUMBER:=utl_call_stack.error_depth;
    BEGIN
        FOR i in 1..v_DEPTH_nr LOOP
            IF utl_call_stack.error_number(i)!=6512 then
                dbms_output.put_line(utl_call_stack.error_number(i)||'-'||
                utl_call_stack.error_msg(i));
            END IF;
        END LOOP;
    END;
    
    PROCEDURE p_misha02 IS
        v_nr NUMBER;
    BEGIN
        SELECT empno 
        INTO v_nr 
        FROM scott.emp; -- multiple rows returned!
    END;

    PROCEDURE p_misha01 IS
    BEGIN
        p_misha02;
    EXCEPTION
        WHEN OTHERS THEN
            raise_application_error(num=>-20001,
                                    msg=>'Contact system administrator!',
                                    keeperrorstack=>true);
    END;
BEGIN
    p_misha01;
EXCEPTION
    WHEN OTHERS THEN
        error_stack; -- print out error stack
END;
/