CREATE OR REPLACE FUNCTION f_getStat_nr (i_name_tx VARCHAR2) RETURN NUMBER IS
    v_out_nr NUMBER;
BEGIN
    SELECT v$mystat.value
    INTO v_out_nr
    FROM v$statname, -- readable names of every statistical element
        v$mystat -- statistics
    WHERE v$mystat.statistic# = v$statname.statistic#
    AND v$statname.name = i_name_tx;

    RETURN v_out_nr;
EXCEPTION
    WHEN NO_DATA_FOUND THEN
        RETURN null;
END;
/