exec runstats_pkg.rs_start;
DECLARE
    type number_tt IS TABLE OF test_tab%ROWTYPE;
    v_tt number_tt;
    v_nr NUMBER;
    v_cur SYS_REFCURSOR;
    v_limit_nr CONSTANT NUMBER:=5000;
BEGIN
    OPEN v_cur FOR SELECT * FROM test_tab;
    LOOP
        FETCH v_cur BULK COLLECT INTO v_tt LIMIT v_limit_nr;
        EXIT WHEN v_tt.count()=0;
        FOR i IN v_tt.first..v_tt.last LOOP
            v_nr:=v_tt(i).object_id;
        END LOOP;
        EXIT WHEN v_tt.count<v_limit_nr;
    END LOOP;
CLOSE v_cur;
END;
/
exec runstats_pkg.rs_middle;
DECLARE
    TYPE table_tt IS TABLE OF test_tab%rowtype;
    v_tt table_tt;
    v_nr NUMBER;
    v_limit_nr CONSTANT NUMBER:=5000;
    v_counter_nr NUMBER:=0;
BEGIN
    LOOP
        SELECT *
        BULK COLLECT INTO v_tt
        FROM test_tab
        OFFSET v_counter_nr*v_limit_nr ROWS
        FETCH NEXT 5000 ROWS ONLY; -- limitation (see note below)
        EXIT WHEN v_tt.count()=0;

        FOR i IN v_tt.first..v_tt.last LOOP
            v_nr:=v_tt(i).object_id;
        END LOOP;
        EXIT WHEN v_tt.count<v_limit_nr;
        v_counter_nr:=v_counter_nr+1;
    END LOOP;
END;
/
exec runstats_pkg.rs_stop;
