DECLARE
    TYPE tt IS TABLE OF NUMBER;
    v_tt tt:=tt(0,10);
    v_emp_tt tt;
BEGIN
    FORALL j IN INDICES OF v_tt
    UPDATE emp
    SET ename = UPPER(ename)
    WHERE (deptno = v_tt(j) or empno=7499)
        RETURNING empno
        BULK COLLECT INTO v_emp_tt;

    FOR i IN v_emp_tt.first..v_emp_tt.last LOOP
        dbms_output.put_line(v_emp_tt(i));
    END LOOP;
END;
/