UPDATE test_tab_main SET object_id = rownum
/
UPDATE test_tab_other SET object_id = rownum
/
alter table test_tab_main add constraint tt_main_pk primary key (object_id)
/
alter table test_tab_other add constraint tt_other_pk primary key (object_id)
/

-- Create updatable view
CREATE OR REPLACE VIEW v_test_tab AS
SELECT 'Main|'||object_id pk_tx,
a.*
FROM test_tab_main a
UNION ALL
SELECT 'Other|'||object_id pk_tx,
a.*
FROM test_tab_other a
/
create or replace trigger v_test_tab_IIUD
instead of insert or update or delete on v_test_tab
begin
    null;
end;
/

-- Check execution plan
set autotrace traceonly explain
UPDATE v_test_tab
SET object_name='Test'
WHERE pk_tx='Main|1'
/
