DECLARE
    gv_data_xml XMLTYPE;
    
    FUNCTION f_checkValue_tx(i_xml XMLTYPE) 
    RETURN VARCHAR2 IS
        v_value_tx VARCHAR2(10);
    BEGIN
        SELECT tag_tx
        INTO v_value_tx
        FROM XMLTable('/root' PASSING i_xml
        COLUMNS tag_tx VARCHAR2(5) PATH 'tag');
        RETURN v_value_tx;
    END;
    
    PROCEDURE p_process_xml (i_xml XMLType)is
    BEGIN
        -- check IN-parameter
        dbms_output.put_line('Check1:'||f_checkValue_tx(i_xml));
        -- change global
        gv_data_xml := XMLTYPE('<root><tag>ABCDE</tag></root>');
        -- change IN-parameter one more time
        dbms_output.put_line('Check2:'||f_checkValue_tx(i_xml));
    END;
BEGIN
    -- assign global variable
    gv_data_xml := XMLTYPE('<root><tag>12345</tag></root>');
    p_process_xml(gv_data_xml);
END;
/